{% extends 'layouts/base_background.html' %}
{% load static %}

{% block title %}
    ZuLab
{% endblock %}
{% block styles %}

<link rel="stylesheet" type="text/css" href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700,900|Roboto+Slab:400,700" />  
<link href="https://fonts.googleapis.com/icon?family=Material+Icons+Round" rel="stylesheet">  
<link href="{% static 'vendor/bootstrap-table/dist/bootstrap-table.min.css'%}" rel="stylesheet"> 
<link href="https://cdn.jsdelivr.net/npm/bootstrap-icons/font/bootstrap-icons.css" rel="stylesheet"> 
<style> 
    .bodyPlanilla td input {
        font-size: 1.2rem;
        text-align: center;
    }
    .bodyPlanilla td span {
        font-size: 1.2rem;
    }
    .td_{
        position: relative;
    }
    .inputtd{
        padding-right: 1rem; 
    }
    .fa-eye {
        position: absolute;
        right: 5px; /* Ajustar la posición a la derecha */
        bottom: 5px; /* Ajustar la posición hacia abajo */
    }
</style>
{% endblock styles %}
{% block body %}
    class="index-page bg-gray-200"
{% endblock %} 

{% block content %}
<div class="card card-body blur shadow-blur mx-3 mx-md-4 mt-6">
    <section>
        <div class="container">
            <div class="row">
                <div class="row justify-content-center text-center my-sm-2">
                    <div class="col-lg-12">
                        <span class="badge bg-primary mb-3">PLANILLA DE ATENCIONES</span>
                        <div class="row">
                            <div class="col-lg-7 mx-auto d-flex justify-content-center flex-column">
                                <div class="card-body">
                                    <div class="row">
                                        <div class="col-md-6">
                                            <div class="input-group input-group-dynamic mb-4 is-filled">
                                                <label class="form-label">Fecha de planilla</label>
                                                <input type="text" name="fecha" class="form-control datepicker flatpickr-input active" required="" id="id_fecha" onblur="verificaTuplas()"readonly="readonly">
                                            </div>
                                        </div>
                                        <div class="col-md-6 ps-2">
                                            <div class="input-group input-group-dynamic is-filled"> 
                                                <label class="form-label">Turno</label>
                                                <select name="turno" class="form-control" onchange="verificaTuplas()" required="" id="id_turno">
                                                    <option value="" selected="">Seleccione el turno.</option> 
                                                    <option value="1" >TURNO MAÑANA</option> 
                                                    <option value="2">TURNO TARDE</option> 
                                                    <option value="3">TURNO NOCHE</option>  
                                                </select>
                                                
                                            </div>
                                        </div>
                                    </div> 
                                </div> 
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>  
        <div class="container">
            <div class="row"> 
                <div class="col-lg-12"> 
                    {% comment %} <div class="row mt-3"> 
                        <div class="col-12">
                            <div class="position-relative border-radius-xl overflow-hidden shadow-lg mb-4">
                                <div class="container border-bottom">
                                    <div class="row justify-space-between py-2">
                                        <div class="col-lg-12 me-auto"> {% endcomment %}  
                                            <table  
                                            id="tableTuplas"
                                            data-toggle="table" 
                                            data-search="true" 
                                            data-page-size="100"
                                            data-show-fullscreen="true"  
                                            data-show-export="true"
                                            data-click-to-select="false"
                                            data-pagination="true" 
                                            data-page-list="[10, 25, 50, 100, all]" 
                                            data-locale="es-ES"  
                                            class="bodyPlanilla"
                                            >
                                                <thead>
                                                    <th>GRUPO</th> 
                                                    <th>ESTUDIO</th> 
                                                    {% for item in grupoArea %}
                                                    <th id="area_{{ item.id }}">{{ item.area }}</th> 
                                                    {% endfor %}
                                                    <th>TOTAL</th>  
                                                </thead> 
                                                <tbody id="bodyPlanillaValores">
                                                    {% for itemEstudio in estudio %}
                                                    <tr style="background-color: {{itemEstudio.grupoEstudio.color}}50;" id="estudio_{{itemEstudio.id}}"> 
                                                        <td style="font-size: 0.6rem;"><b>{{ itemEstudio.grupoEstudio.grupoEstudio }}<b></td>
                                                        <td style="font-size: 0.7rem;"><b>{{ itemEstudio.estudio }}<b></td>
                                                        {% for itemArea in grupoArea %}
                                                        <td class="td_">
                                                            <input class="form-control inputtd" 
                                                                    name="estudio_{{itemEstudio.id}}" 
                                                                    alt="{{itemEstudio.id}}_{{ itemArea.id }}" 
                                                                    id="cnt_{{itemEstudio.id}}_{{ itemArea.id }}" placeholder="0"/>

                                                            <div class="div_">
                                                                <span style="font-size: 0.8rem; color: #cdcdcd;" id="eye_{{itemEstudio.id}}_{{ itemArea.id }}" class="spantd"></span>
                                                                <input type="hidden" id="hid_{{itemEstudio.id}}_{{ itemArea.id }}" value="0" class="hidinputtd">
                                                                <input type="hidden" id="ant_{{itemEstudio.id}}_{{ itemArea.id }}" value="" class="antinputtd">
                                                            </div>

                                                        </td> 
                                                        {% endfor %}  
                                                        <td style="text-align: center;"><b><span id = "span_estudio_{{itemEstudio.id}}" class="totaltd"></span></b></td>  

                                                    </tr>
                                                    {% endfor %}
                                                </tbody> 
                                            </table>  
                                        {% comment %} </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div> {% endcomment %}  
                </div>
            </div>
            <div class="input-group mb-4 input-group-static">
                <label>Observaciones</label>
                <textarea name="message" class="form-control" id="observaciones" rows="3">{{ planilla.observaciones }}</textarea>
            </div> 
            <div class="input-group mb-4 input-group-static">
                <label>Estado de equipos</label>
                <textarea name="message" class="form-control" id="estadoEquipos" rows="3">{{ planilla.estadoEquipos }}</textarea>
            </div> 
            <div class="input-group mb-4 input-group-static">
                <label>Estado de las áreas</label>
                <textarea name="message" class="form-control" id="estadoAreas" rows="3">{{ planilla.estadoAreas }}</textarea>
            </div> 
            <div class="input-group mb-4 input-group-static">
                <label>Pacientes críticos</label>
                <textarea name="message" class="form-control" id="pacientesCriticos" rows="3">{{ planilla.pacientesCriticos }}</textarea>
            </div> 
            <div class="input-group mb-4 input-group-static">
                <a onclick="guardarRegistro('', '')" class="btn btn-sm  bg-gradient-primary  mb-0 me-1 mt-2 mt-md-0">Guardar</a>
            </div> 
        </div>
        
    </section>
</div>
{% endblock %}
{% block javascripts %}    
<script src="{% static 'vendor/bootstrap-table/dist/bootstrap-tablePlanilla.js' %}"></script>
<script src="https://cdn.jsdelivr.net/npm/tableexport.jquery.plugin@1.10.21/tableExport.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/tableexport.jquery.plugin@1.10.21/libs/jsPDF/jspdf.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/tableexport.jquery.plugin@1.10.21/libs/jsPDF-AutoTable/jspdf.plugin.autotable.js"></script> 
<script src="{% static 'vendor/bootstrap-table/dist/extensions/export/bootstrap-table-export.min.js' %}"></script>
<script src="{% static 'vendor/bootstrap-table/dist/bootstrap-table-locale-all.min.js' %}"></script>
<script src="{% static 'js/plugins/flatpickr.min.js' %}"></script>  

<script language="javascript">     
    $(document).ready(function ($) { 
        $('.input-group-dynamic').each(function() {  
            if($(this).find('input').val())
                $(this).addClass('is-filled'); 
            if($(this).find('select'))
                $(this).addClass('is-filled'); 
        });  
        crvIniciaDatatable();
        var idturno = 0;
        var auxFecha_ = new Date();
        {% if planilla.turno.id %}
            idturno = {{ planilla.turno.id }}; 
            {% with fecha_formateada=planilla.fecha|date:"Y-m-d" %} 
                auxFecha_ = "{{ fecha_formateada }}";
            {% endwith %} 
            $('#id_fecha').prop('disabled', true);
            $('#id_turno').prop('disabled', true);
        {% endif %} 
        if(idturno){
            $('#id_turno').val(idturno);
            $('#id_fecha').val(auxFecha_); 
            verificaTuplas();
        }
        if (document.querySelector(".datepicker")) {
            flatpickr(".datepicker", {defaultDate:auxFecha_ });
        }
    }); 
    function sumarValoresDeFila(name,val){ 
        if($('#id_fecha').val()){
            if($('#id_turno').val()){   
                var suma = 0; // Inicializa la suma total 
                $('input[name="'+name+'"]').each(function() { 
                    var valor = parseInt($(this).val(), 10);
                    if (!isNaN(valor) && valor>0 && valor!='') { // Verificar si es un número
                        suma += valor; // Sumarlo al total
                        var idValorAnt = '#ant_'+$(this).attr('alt');
                        var valorAnt = $(idValorAnt).val(); 
                        if(valorAnt != valor)
                            guardarRegistro($(this).attr('alt'), valor);
                    }
                }); 
                $('#span_'+name).html(suma); 
            }else{
                (val?mensaje('Error de validación',"Por favor, seleccione un turno.",'red'):0);
            }
        }else{
            (val?mensaje('Error de validación',"Por favor, ingrese una fecha válida.",'red'):0);
        }
    }
    function guardarRegistro(id_, valor_){  
        $('#id_fecha').prop('disabled', true);
        $('#id_turno').prop('disabled', true); 
        $('#ant_'+id_).val(valor_);  
        var vec = id_.split('_');
        var asoc = {
                    id_fecha:$('#id_fecha').val(), id_turno: $('#id_turno').val(), 
                    id_estudio:vec[0],  id_area:vec[1], valor:valor_, swSave:$('#hid_'+id_).val(),
                    observaciones_:$('#observaciones').val(),
                    estadoEquipos_:$('#estadoEquipos').val(),
                    estadoAreas_:$('#estadoAreas').val(),
                    pacientesCriticos_:$('#pacientesCriticos').val(),
                    };
        console.log("enviando a server:");
        console.log(asoc);
        $.ajax({
            headers : {"X-CSRFToken": '{{csrf_token}}'},
            type:"POST",
            url:"/tupla/save",
            data: JSON.stringify(asoc),
            success: function(response){
                if(response.mensaje==="OK"){ 
                    $('#hid_'+id_).val('1');  
                }
                else
                    mensaje('',"Error al guardar el registro;"+response.error); 
            },
            error: function(jqXHR, textStatus, errorThrow){ 
                mensaje('Excepción',errorThrow,'red'); 
            }
        });
    }
    auxDatCantidades = '';
    function verificaTuplas(){ 
        var fecha_ = $('#id_fecha').val();
        var turno_ = $('#id_turno').val();
        if(fecha_ && turno_){ 
            var asoc = {id_fecha:$('#id_fecha').val(), id_turno: $('#id_turno').val()};
            $.ajax({
                headers : {"X-CSRFToken": '{{csrf_token}}'},
                type:"POST",
                url:"/tupla/verifica",
                data: JSON.stringify(asoc),
                success: function(response){  
                    cerearValoresTupla();  
                    if(response.mensaje == 'NH'){
                        console.log("todo vacio"); 
                    }else{  
                        $('#tableTuplas').bootstrapTable('destroy');  
                        cerearValoresTupla(); 
                        dat = $.parseJSON(response);  
                        $.each(dat, function(index, elemento) { 
                            $('#cnt_'+elemento.fields.estudio+'_'+elemento.fields.grupoArea).val(elemento.fields.cantidad); 
                            $('#ant_'+elemento.fields.estudio+'_'+elemento.fields.grupoArea).val(elemento.fields.cantidad); 
                            $('#eye_'+elemento.fields.estudio+'_'+elemento.fields.grupoArea).html('<a style="cursor: pointer;" onclick="verHistorial('+elemento.pk+')"><i class="fa fa-eye" aria-hidden="true"></i></a>');  
                            sumarValoresDeFila('estudio_'+elemento.fields.estudio,elemento.fields.cantidad); 
                        });  
                        $('#tableTuplas').bootstrapTable(); 
                        auxDatCantidades = dat;
                        vuelveCargaCantidad(); //CRV --> SE AGREGO, PUES AL HACER EL CAMBIO A VISTA DE CARTA, SE CEREABA LOS VALORES DE LOS INPUTS TEXT DE PLANILLAS
                    } 
                },
                error: function(jqXHR, textStatus, errorThrow){ 
                    mensaje('Excepción',textStatus+'|'+errorThrow,'red'); 
                }
            }); 
        }
    }
    function crvIniciaDatatable(){ 
        $('.search-input').css({'border': '1px solid #d2d6da', 'padding': '0.5rem 1rem'}); 
        $('#bodyPlanillaValores').each(function() { 
            $(this).find('input').blur(function(){
                sumarValoresDeFila($(this).attr('name'), $(this).val());
            });
        });
    }
    function vuelveCargaCantidad(){ 
        if(auxDatCantidades){
            $.each(auxDatCantidades, function(index, elemento) {   
                $('#cnt_'+elemento.fields.estudio+'_'+elemento.fields.grupoArea).val(elemento.fields.cantidad);  
            });
        }
        crvIniciaDatatable();
    }
    function cerearValoresTupla(){  
        $("#tableTuplas tbody .inputtd").val(''); 
        $(".spantd").html('');   
        $(".hidinputtd").val('');   
        $(".antinputtd").val('');   
        $("#tableTuplas tbody .totaltd").html('');  
    }
    function verHistorial(idTupla){ 
        var asoc = {idTupla_:idTupla};
        $.ajax({
            headers : {"X-CSRFToken": '{{csrf_token}}'},
            type:"POST",
            url:"/tupla/historico",
            data: JSON.stringify(asoc),
            success: function(response){  
                if(response.error){
                    mensaje('Excepción',response.error,'red');
                }
                else{ 
                    datos = $.parseJSON(response);
                    var filas = '';
                    $.each(datos, function(index, objeto) {
                        filas += '<tr>'; 
                        filas += '<td>' + objeto.history_user_id__username + '</td>';
                        filas += '<td>' + objeto.history_date + '</td>';
                        {% comment %} filas += '<td>' + objeto.planilla + '</td>';
                        filas += '<td>' + objeto.grupoArea + '</td>';
                        filas += '<td>' + objeto.estudio + '</td>'; {% endcomment %}
                        filas += '<td>' + objeto.cantidad + '</td>';
                        filas += '<td>' + (objeto.history_type=='+' ? 'Creación' : 'Modificación') + '</td>';
                        filas += '</tr>';
                    });

                    html = `<div class="container"> 
                        <table id="tabla-datos" class="table">
                            <thead>
                            <tr> 
                                <th>Usuario</th>
                                <th>Fecha de creación</th>
                                {% comment %} <th>Planilla</th>
                                <th>Grupo de área</th>
                                <th>Estudio</th> {% endcomment %}
                                <th>Cantidad</th> 
                                <th>Tipo de historia</th>
                            </tr>
                            </thead>
                            <tbody>
                            ${filas}
                            </tbody>
                        </table>
                    </div>`;  
                    mensaje('Historial del registro:',html,'dark','col-md-12');
                }
            },
            error: function(jqXHR, textStatus, errorThrow){ 
                mensaje('Excepción',textStatus+'|'+errorThrow,'red'); 
            }
        }); 
    }   
</script>
{% endblock javascripts %}